package collections

import (
	"errors"

	"git.perx.ru/perxis/perxis-go/pkg/service"
)

var (
	ErrAlreadyExists        = service.ErrAlreadyExists
	ErrAccessDenied         = service.ErrAccessDenied
	ErrNotFound             = service.ErrNotFound
	ErrRequiredCollection   = errors.New("collection required")
	ErrInvalidCollectionID  = errors.New("collection id not valid")
	ErrRequiredSpaceID      = errors.New("space id required")
	ErrRequiredEnvID        = errors.New("environment id required")
	ErrRequiredCollectionID = errors.New("collection id required")
	ErrRequiredSchema       = errors.New("schema required")
	ErrConvertToSingle      = errors.New("cannot convert collection to 'single'")
)
